
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef joystick_ERROR_H
#define joystick_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_joystick    (12000)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_joystick_ERROR_JOYSTICK_INIT  H2_ENCODE_ERR(M_joystick  , 1)
#define S_joystick_ERROR_JOYSTICK       H2_ENCODE_ERR(M_joystick  , 2)


/* std errors */
#define S_joystick_stdGenoM_ACTIVITY_INTERRUPTED       786490369   /* 12000<<16 | 0x8000 | 100<<8 | 1 */
#define S_joystick_stdGenoM_TOO_MANY_ACTIVITIES        786490370   /* 12000<<16 | 0x8000 | 100<<8 | 2 */
#define S_joystick_stdGenoM_ACTIVITY_FAILED            786490371   /* 12000<<16 | 0x8000 | 100<<8 | 3 */
#define S_joystick_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 786490372   /* 12000<<16 | 0x8000 | 100<<8 | 4 */
#define S_joystick_stdGenoM_UNKNOWN_ACTIVITY           786490373   /* 12000<<16 | 0x8000 | 100<<8 | 5 */
#define S_joystick_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 786490374   /* 12000<<16 | 0x8000 | 100<<8 | 6 */
#define S_joystick_stdGenoM_SYSTEM_ERROR               786490375   /* 12000<<16 | 0x8000 | 100<<8 | 7 */
#define S_joystick_stdGenoM_ACTIVITY_ALREADY_ENDED     786490376   /* 12000<<16 | 0x8000 | 100<<8 | 8 */
#define S_joystick_stdGenoM_WAIT_INIT_RQST             786490377   /* 12000<<16 | 0x8000 | 100<<8 | 9 */
#define S_joystick_stdGenoM_CONTROL_CODEL_ERROR        786490378   /* 12000<<16 | 0x8000 | 100<<8 | 10 */
#define S_joystick_stdGenoM_EXEC_TASK_SUSPENDED        786490379   /* 12000<<16 | 0x8000 | 100<<8 | 11 */
#define S_joystick_stdGenoM_BAD_BLOCK_TYPE             786490380   /* 12000<<16 | 0x8000 | 100<<8 | 12 */
#define S_joystick_stdGenoM_BAD_POSTER_TYPE            786490381   /* 12000<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define JOYSTICK_H2_ERR_MSGS {\
    {"ERROR_JOYSTICK_INIT", 1},\
    {"ERROR_JOYSTICK", 2},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int joystickRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
